

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_minimum -45.0
#property indicator_maximum 45.0
#property indicator_color1  Orange
#property indicator_color2  LawnGreen
#property indicator_color3  Red
#property indicator_color4  Blue
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_level2  12.0
#property indicator_level3  -12.0

//
//
//
//
//

extern int                Per             = 5;
extern ENUM_MA_METHOD     Ma_Type         = 0;
extern ENUM_APPLIED_PRICE Price           = 4;
extern string             note            = "turn on Alert = true; turn off = false";
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = true;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;
extern string             soundFile       = "alert2.wav";

double AboveBuff[];
double ShortBuff[];
double LongBuffe[];
double BelowBuff[];

// ---
int init() 
{
   SetIndexBuffer(0,AboveBuff); SetIndexStyle(0,DRAW_HISTOGRAM);  SetIndexLabel(0, "Above");                     
   SetIndexBuffer(1,BelowBuff); SetIndexStyle(1,DRAW_HISTOGRAM);  SetIndexLabel(1, "Below");                          
   SetIndexBuffer(2,ShortBuff); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,108); 
   SetIndexBuffer(3,LongBuffe); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,108); 
   
   SetLevelStyle(STYLE_DOT, 0, SteelBlue);
   IndicatorShortName(" Forex MTN ");
return (0);
}
	 	    			  		  		   		 	 	 	 	 		 						 	   				  	   	 		 			  			  	     		  	 			   	 	     			 	 		 		     			 	 	  		 	  		   			 			    	
int deinit() { return(0);}
		    			 	 			 	 	  	  		  	   	 				 			     		 	 	 	 		 	 	 	 	 		 		 		  	    					   		  	    	 					 	  	    	 			 	 	 		 	 	  	 	   	  	 	
// 
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
      
   for (int i = limit; i >=0; i--) 
   {
       double Main = iMA(NULL,0,Per,0,Ma_Type,Price,i);
       double Minr = 0.2 * iATR(NULL,0,Per,i);
         
            if (Minr!=0)
            {
               AboveBuff[i] = 3.0 * (High[i] - Main) / Minr;
               BelowBuff[i] = 3.0 * ( Low[i] - Main) / Minr;
            }
            
            //
            //
            //
            //
            //
            
            ShortBuff[i] = EMPTY_VALUE;
            LongBuffe[i] = EMPTY_VALUE;
            if (AboveBuff[i] >  24.0) ShortBuff[i] =  25;
            if (BelowBuff[i] < -24.0) LongBuffe[i] = -25;
      }
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (ShortBuff[whichBar] != EMPTY_VALUE || LongBuffe[whichBar] != EMPTY_VALUE)
      {
         if (ShortBuff[whichBar] !=  EMPTY_VALUE) doAlert(whichBar,"down");
         if (LongBuffe[whichBar] !=  EMPTY_VALUE) doAlert(whichBar,"up");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ForexMTN ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ForexMTN "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}
 